local _, class = UnitClass("player");
local simpleEclipseBar = {}

simpleEclipseBar.eclipseBarOptions = CreateFrame( "Frame", "eclipseBarPanel", UIParent )
simpleEclipseBar.eclipseBarOptions:RegisterEvent("PLAYER_LOGIN")
simpleEclipseBar.eclipseBarOptions:SetScript("OnEvent", function(self, event, addon)
        if (class == "DRUID") then

            if simpleEclipseBarDB == nil then
                simpleEclipseBarDB = {}
                simpleEclipseBarDB["X"] = "0"
                simpleEclipseBarDB["Y"] = "0"
                simpleEclipseBarDB["Height"] = "20"
                simpleEclipseBarDB["Width"] = "200"
            end

            simpleEclipseBar.eclipseBarOptions.name = "simpleEclipseBar"
            local y = -100;
            simpleEclipseBar.addOption("X",10,y,function(self)
                local _,_,_,_,yOffset = simpleEclipseBar.eclipseBar:GetPoint(1)
                simpleEclipseBarDB["X"] = self:GetText()
                simpleEclipseBar.eclipseBar:SetPoint("CENTER",UIParent,"CENTER",simpleEclipseBarDB["X"],yOffset)
            end)
            simpleEclipseBar.addOption("Y",110,y,function(self)
                local _,_,_,xOffset,_ = simpleEclipseBar.eclipseBar:GetPoint(1)
                simpleEclipseBarDB["Y"] = self:GetText()
                simpleEclipseBar.eclipseBar:SetPoint("CENTER",UIParent,"CENTER",xOffset,simpleEclipseBarDB["Y"])
            end)

            simpleEclipseBar.addOption("Height",210,y,function(self)
                simpleEclipseBarDB["Height"] = self:GetText()
                simpleEclipseBar.eclipseBar:SetHeight(simpleEclipseBarDB["Height"])
                simpleEclipseBar.eclipseBar.barBackground:SetHeight(simpleEclipseBarDB["Height"]+10)
            end)

            simpleEclipseBar.addOption("Width",310,y,function(self)
                simpleEclipseBarDB["Width"] = self:GetText()
                simpleEclipseBar.eclipseBar:SetWidth(simpleEclipseBarDB["Width"])
                simpleEclipseBar.eclipseBar.barBackground:SetWidth(simpleEclipseBarDB["Width"]+10)
            end)

            local talentTree,_ = GetSpecializationInfo(GetSpecialization())
            simpleEclipseBar.displayState = talentTree == 102
            if simpleEclipseBar.displayState then
                simpleEclipseBar.initializeSimpleEclipseBar()
            end
            simpleEclipseBar.eclipseBarOptions:RegisterEvent("PLAYER_TALENT_UPDATE")
            simpleEclipseBar.eclipseBarOptions:SetScript("OnEvent", function ()
                local talentTree,_ = GetSpecializationInfo(GetSpecialization())
                local currentDisplayState = talentTree == 102
                if currentDisplayState ~= simpleEclipseBar.displayState then
                    simpleEclipseBar.displayState = currentDisplayState
                    if simpleEclipseBar.displayState then
                        if simpleEclipseBar.eclipseBar then
                            simpleEclipseBar.eclipseBar:Show()
                        else
                            simpleEclipseBar.initializeSimpleEclipseBar()
                        end
                    else
                        if simpleEclipseBar.eclipseBar then
                            simpleEclipseBar.eclipseBar:Hide()
                        end
                    end
                end
            end)
            InterfaceOptions_AddCategory(simpleEclipseBar.eclipseBarOptions)
        end
end)

simpleEclipseBar.checkBuffs = function ()
    local hasLunarEclipse = false;
    local hasSolarEclipse = false;

    local unit = PlayerFrame.unit;
    local j = 1;
    local name, _, _, _, _, _, _, _, _, _, spellID = UnitBuff(unit, j);
    while name do
        if spellID == ECLIPSE_BAR_SOLAR_BUFF_ID then
            hasSolarEclipse = true;
        elseif spellID == ECLIPSE_BAR_LUNAR_BUFF_ID then
            hasLunarEclipse = true;
        end
        j=j+1;
        name, _, _, _, _, _, _, _, _, _, spellID = UnitBuff(unit, j);
    end

    if hasLunarEclipse then
        if not simpleEclipseBar.eclipseBar.barBackground.flashAnimation:IsPlaying() then
            simpleEclipseBar.eclipseBar.barBackground.texture:SetTexture(0, 0, 1, 1)
            simpleEclipseBar.eclipseBar.barBackground.flashAnimation:Play()
        end
    elseif hasSolarEclipse then
        if not simpleEclipseBar.eclipseBar.barBackground.flashAnimation:IsPlaying() then
            simpleEclipseBar.eclipseBar.barBackground.texture:SetTexture(1, 1, 0, 1)
            simpleEclipseBar.eclipseBar.barBackground.flashAnimation:Play()
        end
    else
        if simpleEclipseBar.eclipseBar.barBackground.flashAnimation:IsPlaying() then
            simpleEclipseBar.eclipseBar.barBackground.flashAnimation:Stop()
        end
    end
end

simpleEclipseBar.addOption = function (name,x,y,func)
    simpleEclipseBar.eclipseBarOptions[name] = CreateFrame("EditBox", nil, simpleEclipseBar.eclipseBarOptions)
    simpleEclipseBar.eclipseBarOptions[name]:SetWidth(80)
    simpleEclipseBar.eclipseBarOptions[name]:SetHeight(25)
    simpleEclipseBar.eclipseBarOptions[name]:SetPoint("TOPLEFT", simpleEclipseBar.eclipseBarOptions, "TOPLEFT", x, y)
    simpleEclipseBar.eclipseBarOptions[name]:SetAutoFocus(false)
    simpleEclipseBar.eclipseBarOptions[name]:SetScript("OnEscapePressed", function(self) self:ClearFocus() end)
    simpleEclipseBar.eclipseBarOptions[name]:SetScript("OnEnterPressed", func)
    simpleEclipseBar.eclipseBarOptions[name]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        tile = true, tileSize = 16, edgeSize = 16,
        insets = { left = 4, right = 4, top = 4, bottom = 4 }})
    simpleEclipseBar.eclipseBarOptions[name]:SetJustifyH("CENTER")
    simpleEclipseBar.eclipseBarOptions[name]:SetBackdropBorderColor(1,1,1,1)
    simpleEclipseBar.eclipseBarOptions[name]:SetBackdropColor(0,0,0,1)
    simpleEclipseBar.eclipseBarOptions[name]:SetFontObject("GameFontHighlight")
    simpleEclipseBar.eclipseBarOptions[name]:SetText(simpleEclipseBarDB[name])
    simpleEclipseBar.eclipseBarOptions[name]:SetCursorPosition(0)
    simpleEclipseBar.eclipseBarOptions[name].label = simpleEclipseBar.eclipseBarOptions[name]:CreateFontString(nil, "OVERLAY")
    simpleEclipseBar.eclipseBarOptions[name].label:SetPoint("CENTER", simpleEclipseBar.eclipseBarOptions[name], "CENTER", 0, -20)
    simpleEclipseBar.eclipseBarOptions[name].label:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
    simpleEclipseBar.eclipseBarOptions[name].label:SetJustifyH("CENTER")
    simpleEclipseBar.eclipseBarOptions[name].label:SetShadowOffset(1, -1)
    simpleEclipseBar.eclipseBarOptions[name].label:SetTextColor(1, 1, 1)
    simpleEclipseBar.eclipseBarOptions[name].label:SetText(name)
end

simpleEclipseBar.initializeSimpleEclipseBar =  function  ()
    EclipseBarFrame:UnregisterAllEvents()
    EclipseBarFrame:Hide()
    EclipseBarFrame:SetScript("OnShow", function(self) self:Hide() end)
    simpleEclipseBar.eclipseBar = CreateFrame("StatusBar", nil, UIParent)
    simpleEclipseBar.eclipseBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
    simpleEclipseBar.eclipseBar:GetStatusBarTexture():SetHorizTile(false)
    simpleEclipseBar.eclipseBar:SetFrameStrata("LOW")
    simpleEclipseBar.eclipseBar:SetMinMaxValues(-100, 100)
    simpleEclipseBar.eclipseBar:SetValue(UnitPower( "player", SPELL_POWER_ECLIPSE ))
    simpleEclipseBar.eclipseBar:SetWidth(simpleEclipseBarDB["Width"])
    simpleEclipseBar.eclipseBar:SetHeight(simpleEclipseBarDB["Height"])
    simpleEclipseBar.eclipseBar:SetPoint("CENTER", simpleEclipseBar.barBackground, "CENTER", simpleEclipseBarDB["X"], simpleEclipseBarDB["Y"])
    simpleEclipseBar.eclipseBar:SetStatusBarColor(1,1,0)
    simpleEclipseBar.eclipseBar:RegisterEvent("UNIT_POWER")
    simpleEclipseBar.eclipseBar:RegisterEvent("ECLIPSE_DIRECTION_CHANGE");
    simpleEclipseBar.eclipseBar:SetScript("OnEvent", function(self, event, arg1, arg2)
        if event == "UNIT_POWER" and arg2 == "ECLIPSE" and arg1 == "player" then
            self:SetValue(UnitPower( "player", SPELL_POWER_ECLIPSE ))
            simpleEclipseBar.checkBuffs()
        elseif event == "ECLIPSE_DIRECTION_CHANGE" then
            if arg1 == "sun" then
                simpleEclipseBar.eclipseBar.value:SetText(">")
            else
                simpleEclipseBar.eclipseBar.value:SetText("<")
            end
        end
    end)

    simpleEclipseBar.eclipseBar.bg = simpleEclipseBar.eclipseBar:CreateTexture(nil, "BACKGROUND")
    simpleEclipseBar.eclipseBar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
    simpleEclipseBar.eclipseBar.bg:SetAllPoints()
    simpleEclipseBar.eclipseBar.bg:SetVertexColor(0, 0, 1)

    simpleEclipseBar.eclipseBar.value = simpleEclipseBar.eclipseBar:CreateFontString(nil, "OVERLAY")
    simpleEclipseBar.eclipseBar.value:SetPoint("CENTER", simpleEclipseBar.eclipseBar, "CENTER", 0, 0)
    simpleEclipseBar.eclipseBar.value:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
    simpleEclipseBar.eclipseBar.value:SetJustifyH("CENTER")
    simpleEclipseBar.eclipseBar.value:SetShadowOffset(1, -1)
    simpleEclipseBar.eclipseBar.value:SetTextColor(1, 1, 1)
    simpleEclipseBar.eclipseBar.value:SetText(">")

    simpleEclipseBar.eclipseBar.barBackground = CreateFrame("Frame", nil, simpleEclipseBar.eclipseBar)
    simpleEclipseBar.eclipseBar.barBackground:SetFrameStrata("BACKGROUND")
    simpleEclipseBar.eclipseBar.barBackground:SetWidth(210)
    simpleEclipseBar.eclipseBar.barBackground:SetHeight(30)
    simpleEclipseBar.eclipseBar.barBackground:SetPoint("CENTER", simpleEclipseBar.eclipseBar, "CENTER", 0, 0)
    simpleEclipseBar.eclipseBar.barBackground:SetAlpha(0)
    simpleEclipseBar.eclipseBar.barBackground.texture = simpleEclipseBar.eclipseBar.barBackground:CreateTexture(nil, "BACKGROUND")
    simpleEclipseBar.eclipseBar.barBackground.texture:SetAllPoints(true)
    simpleEclipseBar.eclipseBar.barBackground.texture:SetTexture(1, 1, 0, 1)

    simpleEclipseBar.eclipseBar.barBackground.flashAnimation = simpleEclipseBar.eclipseBar.barBackground:CreateAnimationGroup()
    simpleEclipseBar.eclipseBar.barBackground.flashAnimation:SetLooping("BOUNCE")

    local fadeIn = simpleEclipseBar.eclipseBar.barBackground.flashAnimation:CreateAnimation("Alpha")
    fadeIn:SetDuration(1)
    fadeIn:SetChange(1)
    fadeIn:SetOrder(1)
    fadeIn:SetEndDelay(0)

    local fadeOut = simpleEclipseBar.eclipseBar.barBackground.flashAnimation:CreateAnimation("Alpha")
    fadeOut:SetDuration(1)
    fadeOut:SetChange(-1)
    fadeOut:SetOrder(2)
    fadeOut:SetEndDelay(0)

    simpleEclipseBar.checkBuffs()
    if GetEclipseDirection() == "sun" then
        simpleEclipseBar.eclipseBar.value:SetText(">")
    else
        simpleEclipseBar.eclipseBar.value:SetText("<")
    end
end